package cn.timer.api.bean.zpgl;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

/**
 * 招聘管理职位信息表
 * 
 * @author wuqingjun
 * @email 284718418@qq.com
 * @date 2022-03-08 15:14:40
 */
@Entity
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "zpgl_zwxx")
@Data
public class ZpglZwxx extends Model<ZpglZwxx> {
	private static final long serialVersionUID = 1L;
	/**
	 * 主键ID
	 */
	@Id
	@GeneratedValue
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "编号")
	private Integer id;
	/**
	* 职位名称
	*/
	@ApiModelProperty(value = "职位名称")
	private String name;
	/**
	* 部门id
	*/
	@ApiModelProperty(value = "部门id")
	private Integer deptId;
	/**
	* 工作性质 1:全职 2:兼职 3:实习 4:退休返聘 5:劳务外派 6:劳务外包
	*/
	@ApiModelProperty(value = "工作性质 1:全职 2:兼职 3:实习 4:退休返聘 5:劳务外派 6:劳务外包")
	private Integer workType;
	/**
	* 工作城市
	*/
	@ApiModelProperty(value = "工作城市")
	private String city;
	/**
	* 工作地点
	*/
	@ApiModelProperty(value = "工作地点")
	private String address;
	/**
	* 招聘人数
	*/
	@ApiModelProperty(value = "招聘人数")
	private Integer num;
	/**
	* 已入职人数
	*/
	@ApiModelProperty(value = "已入职人数")
	private Integer entryNum;
	/**
	* 招聘原因
	*/
	@ApiModelProperty(value = "招聘原因")
	private String reason;
	/**
	* 工作经验要求
	*/
	@ApiModelProperty(value = "工作经验要求")
	private String experience;
	/**
	* 学历要求
	*/
	@ApiModelProperty(value = "学历要求")
	private String education;
	/**
	* 薪资范围
	*/
	@ApiModelProperty(value = "薪资范围")
	private Integer salaryMin;
	/**
	* 薪资范围
	*/
	@ApiModelProperty(value = "薪资范围")
	private Integer salaryMax;
	/**
	* 最迟到岗时间
	*/
	@ApiModelProperty(value = "最迟到岗时间")
	private Long registerTime;
	/**
	* 启动时间
	*/
	@ApiModelProperty(value = "启动时间")
	private Long startTime;
	/**
	* 描述
	*/
	@ApiModelProperty(value = "描述")
	private String description;
	/**
	* 注册时间
	*/
	@ApiModelProperty(value = "注册时间")
	private Long createtime;
	/**
	* 紧急程度状态 1:一般 2:紧急
	*/
	@ApiModelProperty(value = "紧急程度状态 1:一般 2:紧急")
	private Integer urgentStatus;
	/**
	* 状态 1:招聘中 2:停止招聘
	*/
	@ApiModelProperty(value = "状态 1:招聘中 2:停止招聘")
	private Integer status;
	/**
	* 组织机构代码
	*/
	@ApiModelProperty(value = "组织机构代码")
	private String orgCode;

}
